// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_check

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v5/models"
)

// DeleteHTTPCheckAcceptedCode is the HTTP code returned for type DeleteHTTPCheckAccepted
const DeleteHTTPCheckAcceptedCode int = 202

/*
DeleteHTTPCheckAccepted Configuration change accepted and reload requested

swagger:response deleteHttpCheckAccepted
*/
type DeleteHTTPCheckAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`
}

// NewDeleteHTTPCheckAccepted creates DeleteHTTPCheckAccepted with default headers values
func NewDeleteHTTPCheckAccepted() *DeleteHTTPCheckAccepted {

	return &DeleteHTTPCheckAccepted{}
}

// WithReloadID adds the reloadId to the delete Http check accepted response
func (o *DeleteHTTPCheckAccepted) WithReloadID(reloadID string) *DeleteHTTPCheckAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the delete Http check accepted response
func (o *DeleteHTTPCheckAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WriteResponse to the client
func (o *DeleteHTTPCheckAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(202)
}

// DeleteHTTPCheckNoContentCode is the HTTP code returned for type DeleteHTTPCheckNoContent
const DeleteHTTPCheckNoContentCode int = 204

/*
DeleteHTTPCheckNoContent HTTP check deleted

swagger:response deleteHttpCheckNoContent
*/
type DeleteHTTPCheckNoContent struct {
}

// NewDeleteHTTPCheckNoContent creates DeleteHTTPCheckNoContent with default headers values
func NewDeleteHTTPCheckNoContent() *DeleteHTTPCheckNoContent {

	return &DeleteHTTPCheckNoContent{}
}

// WriteResponse to the client
func (o *DeleteHTTPCheckNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// DeleteHTTPCheckNotFoundCode is the HTTP code returned for type DeleteHTTPCheckNotFound
const DeleteHTTPCheckNotFoundCode int = 404

/*
DeleteHTTPCheckNotFound The specified resource was not found

swagger:response deleteHttpCheckNotFound
*/
type DeleteHTTPCheckNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteHTTPCheckNotFound creates DeleteHTTPCheckNotFound with default headers values
func NewDeleteHTTPCheckNotFound() *DeleteHTTPCheckNotFound {

	return &DeleteHTTPCheckNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the delete Http check not found response
func (o *DeleteHTTPCheckNotFound) WithConfigurationVersion(configurationVersion string) *DeleteHTTPCheckNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete Http check not found response
func (o *DeleteHTTPCheckNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete Http check not found response
func (o *DeleteHTTPCheckNotFound) WithPayload(payload *models.Error) *DeleteHTTPCheckNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete Http check not found response
func (o *DeleteHTTPCheckNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteHTTPCheckNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
DeleteHTTPCheckDefault General Error

swagger:response deleteHttpCheckDefault
*/
type DeleteHTTPCheckDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteHTTPCheckDefault creates DeleteHTTPCheckDefault with default headers values
func NewDeleteHTTPCheckDefault(code int) *DeleteHTTPCheckDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteHTTPCheckDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete HTTP check default response
func (o *DeleteHTTPCheckDefault) WithStatusCode(code int) *DeleteHTTPCheckDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete HTTP check default response
func (o *DeleteHTTPCheckDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the delete HTTP check default response
func (o *DeleteHTTPCheckDefault) WithConfigurationVersion(configurationVersion string) *DeleteHTTPCheckDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete HTTP check default response
func (o *DeleteHTTPCheckDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete HTTP check default response
func (o *DeleteHTTPCheckDefault) WithPayload(payload *models.Error) *DeleteHTTPCheckDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete HTTP check default response
func (o *DeleteHTTPCheckDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteHTTPCheckDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
