// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_error_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"context"
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/haproxytech/client-native/v5/models"
)

// GetHTTPErrorRuleHandlerFunc turns a function with the right signature into a get HTTP error rule handler
type GetHTTPErrorRuleHandlerFunc func(GetHTTPErrorRuleParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetHTTPErrorRuleHandlerFunc) Handle(params GetHTTPErrorRuleParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetHTTPErrorRuleHandler interface for that can handle valid get HTTP error rule params
type GetHTTPErrorRuleHandler interface {
	Handle(GetHTTPErrorRuleParams, interface{}) middleware.Responder
}

// NewGetHTTPErrorRule creates a new http.Handler for the get HTTP error rule operation
func NewGetHTTPErrorRule(ctx *middleware.Context, handler GetHTTPErrorRuleHandler) *GetHTTPErrorRule {
	return &GetHTTPErrorRule{Context: ctx, Handler: handler}
}

/*
	GetHTTPErrorRule swagger:route GET /services/haproxy/configuration/http_error_rules/{index} HTTPErrorRule getHttpErrorRule

# Return one HTTP Error Rule

Returns one HTTP Error Rule configuration by its index in the specified parent.
*/
type GetHTTPErrorRule struct {
	Context *middleware.Context
	Handler GetHTTPErrorRuleHandler
}

func (o *GetHTTPErrorRule) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewGetHTTPErrorRuleParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetHTTPErrorRuleOKBody get HTTP error rule o k body
//
// swagger:model GetHTTPErrorRuleOKBody
type GetHTTPErrorRuleOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	Data *models.HTTPErrorRule `json:"data,omitempty"`
}

// Validate validates this get HTTP error rule o k body
func (o *GetHTTPErrorRuleOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetHTTPErrorRuleOKBody) validateData(formats strfmt.Registry) error {
	if swag.IsZero(o.Data) { // not required
		return nil
	}

	if o.Data != nil {
		if err := o.Data.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("getHttpErrorRuleOK" + "." + "data")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("getHttpErrorRuleOK" + "." + "data")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this get HTTP error rule o k body based on the context it is used
func (o *GetHTTPErrorRuleOKBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := o.contextValidateData(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetHTTPErrorRuleOKBody) contextValidateData(ctx context.Context, formats strfmt.Registry) error {

	if o.Data != nil {
		if err := o.Data.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("getHttpErrorRuleOK" + "." + "data")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("getHttpErrorRuleOK" + "." + "data")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetHTTPErrorRuleOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetHTTPErrorRuleOKBody) UnmarshalBinary(b []byte) error {
	var res GetHTTPErrorRuleOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
