// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package mailers

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"context"
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/haproxytech/client-native/v5/models"
)

// GetMailersSectionsHandlerFunc turns a function with the right signature into a get mailers sections handler
type GetMailersSectionsHandlerFunc func(GetMailersSectionsParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetMailersSectionsHandlerFunc) Handle(params GetMailersSectionsParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetMailersSectionsHandler interface for that can handle valid get mailers sections params
type GetMailersSectionsHandler interface {
	Handle(GetMailersSectionsParams, interface{}) middleware.Responder
}

// NewGetMailersSections creates a new http.Handler for the get mailers sections operation
func NewGetMailersSections(ctx *middleware.Context, handler GetMailersSectionsHandler) *GetMailersSections {
	return &GetMailersSections{Context: ctx, Handler: handler}
}

/*
	GetMailersSections swagger:route GET /services/haproxy/configuration/mailers_section Mailers getMailersSections

# Return an array of mailers sections

Returns an array of all the configured mailers in HAProxy
*/
type GetMailersSections struct {
	Context *middleware.Context
	Handler GetMailersSectionsHandler
}

func (o *GetMailersSections) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewGetMailersSectionsParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetMailersSectionsOKBody get mailers sections o k body
//
// swagger:model GetMailersSectionsOKBody
type GetMailersSectionsOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	// Required: true
	Data models.MailersSections `json:"data"`
}

// Validate validates this get mailers sections o k body
func (o *GetMailersSectionsOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetMailersSectionsOKBody) validateData(formats strfmt.Registry) error {

	if err := validate.Required("getMailersSectionsOK"+"."+"data", "body", o.Data); err != nil {
		return err
	}

	if err := o.Data.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("getMailersSectionsOK" + "." + "data")
		} else if ce, ok := err.(*errors.CompositeError); ok {
			return ce.ValidateName("getMailersSectionsOK" + "." + "data")
		}
		return err
	}

	return nil
}

// ContextValidate validate this get mailers sections o k body based on the context it is used
func (o *GetMailersSectionsOKBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := o.contextValidateData(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetMailersSectionsOKBody) contextValidateData(ctx context.Context, formats strfmt.Registry) error {

	if err := o.Data.ContextValidate(ctx, formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("getMailersSectionsOK" + "." + "data")
		} else if ce, ok := err.(*errors.CompositeError); ok {
			return ce.ValidateName("getMailersSectionsOK" + "." + "data")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetMailersSectionsOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetMailersSectionsOKBody) UnmarshalBinary(b []byte) error {
	var res GetMailersSectionsOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
